.386
.model flat,stdcall
option casemap:none

include Basics2.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,OFFSET MenuName
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL	buffer[128]:BYTE	;/* our local variable for reading from the textfile, acces local variables with: addr */

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push		hWin
		pop		hWnd
		
		invoke  GetMenu, hWnd              ; Get handle to main menu
		mov     hMenu, eax
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			jmp Exit
			
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,offset AppName,offset AboutMsg,NULL
			
		.elseif eax==1001
			invoke EnableMenuItem, hMenu, 0, MF_DISABLED or MF_BYPOSITION or MF_DISABLED
			invoke EnableMenuItem, hMenu, 0, MF_DISABLED or MF_BYPOSITION or MF_GRAYED
		.elseif eax==1002
			invoke EnableMenuItem, hMenu, 0, MF_ENABLED or MF_BYPOSITION or MF_ENABLED
			
		.elseif eax==1003
			Exit:
		        invoke MessageBox,hWin,offset Quit,offset AppName,MB_YESNO
          		.if eax == IDNO
            			ret
          		.endif
			invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			
		.elseif eax==1004
			;/* NOTE: This sample is not the best way to read and write from text, its the easiest for this demo */
			; Create a new file, overwrite any existing file.
			invoke CreateFile, offset szFile, GENERIC_WRITE, FILE_SHARE_WRITE, 0, CREATE_ALWAYS, 0, 0
			.if eax!=INVALID_HANDLE_VALUE		;if file exists ... then
				mov hFile, eax
	         		; Write our string the the file
				invoke WriteFile, hFile, offset WriteString, sizeof WriteString, offset WriteSize, 0
	         		; Close handle to file
				invoke CloseHandle, hFile
			.else
				invoke MessageBeep,MB_OK
			.endif
			
		.elseif eax==1007
			; Create a new file, overwrite any existing file.
			invoke CreateFile, offset szFile, GENERIC_READ,FILE_SHARE_READ, 0,OPEN_EXISTING, 0, 0
			.if eax!=INVALID_HANDLE_VALUE		;if file exists ... then
				mov hFile, eax
		         	; Write our string the the file
				invoke ReadFile,hFile,addr buffer,sizeof buffer,offset WriteSize,0
				invoke MessageBox,hWin,addr buffer,offset AppName,MB_OK
		         	; Close handle to file
				invoke CloseHandle, hFile
			.else
				invoke MessageBeep,MB_OK
			.endif
		
		.elseif eax==1008
			invoke CreateDialogParam,hInstance,2000,hWin,offset NewDlgProc,FALSE
		.elseif eax==1006
			invoke SendDlgItemMessage,hWin,1005,SB_SETTEXT,0,offset AppName
		.endif

	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

NewDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==2001
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,NULL
	.else
		mov eax,FALSE
		ret
	.endif
	mov  eax,TRUE
	ret

NewDlgProc endp

end start
